// racetoseven.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"
#include "TextUtils.h"
#include <string>
#include <map>
#include <vector>
#include <fstream>

BZ_GET_PLUGIN_VERSION

std::string version = "0.11.1";

int cap_num = 7;
int cap_num_orig = 7;
std::string URL;
std::string URL_orig;
bool allow_players = false;
bool allow_players_orig = false;
bool allow_matches = true;
bool allow_matches_orig = true;

bool match_in_progress = false;
std::string report_data;
bool bluePlay;
bool redPlay;
bool greenPlay;
bool purplePlay;

bool parseConfig(const char *filename);

//Here's the function that ends matches
void end_match(bz_EventData *eventData){
	bzAPIIntList	*playerList = bz_newIntList();
	bz_getPlayerIndexList(playerList);
	for (int i = 0; i < (int)playerList->size(); i++) {
		bz_PlayerRecord *data = bz_getPlayerByIndex(i);
		report_data += "&player_" + TextUtils::format("%d", i) + "=callsign:";
		report_data += TextUtils::replace_all(TextUtils::format("%s", data->callsign.c_str()), ":", "");
		report_data += ":email:";
		report_data += TextUtils::replace_all(TextUtils::format("%s", data->email.c_str()), ":", "");
		report_data += ":team:";
		if(data->team == eRogueTeam) report_data += "yellow:";
		if(data->team == eRedTeam) report_data += "red:";
		if(data->team == eGreenTeam) report_data += "green:";
		if(data->team == eBlueTeam) report_data += "blue:";
		if(data->team == ePurpleTeam) report_data += "purple:";
		if(data->team == eObservers) report_data += "black:";
	}
	//Get team info

	//Red team
	report_data += "&redscore=";
	int RedTeaminfo = bz_getTeamScore(eRedTeam);
	report_data += TextUtils::format("%d",RedTeaminfo);
	report_data += "&redwins=";

	RedTeaminfo = bz_getTeamWins(eRedTeam);
	if(!eventData){
	}else{
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == eRedTeam) RedTeaminfo++;
	}

	report_data += TextUtils::format("%d",RedTeaminfo);
	report_data += "&redlosses=";
	RedTeaminfo = bz_getTeamLosses(eRedTeam);
	report_data += TextUtils::format("%d",RedTeaminfo);

	//Blue team
	report_data += "&bluescore=";
	int BlueTeaminfo = bz_getTeamScore(eBlueTeam);
	report_data += TextUtils::format("%d",BlueTeaminfo);
	report_data += "&bluewins=";

	BlueTeaminfo = bz_getTeamWins(eBlueTeam);
	if(!eventData){
	}else{
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == eBlueTeam) BlueTeaminfo++;
	}

	report_data += TextUtils::format("%d",BlueTeaminfo);
	report_data += "&bluelosses=";
	BlueTeaminfo = bz_getTeamLosses(eBlueTeam);
	report_data += TextUtils::format("%d",BlueTeaminfo);

	//Green team
	report_data += "&greenscore=";
	int GreenTeaminfo = bz_getTeamScore(eGreenTeam);
	report_data += TextUtils::format("%d",GreenTeaminfo);
	report_data += "&greenwins=";

	GreenTeaminfo = bz_getTeamWins(eGreenTeam);
	if(!eventData){
	}else{
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == eGreenTeam) GreenTeaminfo++;
	}

	report_data += TextUtils::format("%d",GreenTeaminfo);
	report_data += "&greenlosses=";
	GreenTeaminfo = bz_getTeamLosses(eGreenTeam);
	report_data += TextUtils::format("%d",GreenTeaminfo);

	//Purple team
	report_data += "&purplescore=";
	int PurpleTeaminfo = bz_getTeamScore(ePurpleTeam);
	report_data += TextUtils::format("%d",PurpleTeaminfo);
	report_data += "&purplewins=";

	PurpleTeaminfo = bz_getTeamWins(ePurpleTeam);
	if(!eventData){
	}else{
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == ePurpleTeam) PurpleTeaminfo++;
	}

	report_data += TextUtils::format("%d",PurpleTeaminfo);
	report_data += "&purplelosses=";
	PurpleTeaminfo = bz_getTeamLosses(ePurpleTeam);
	report_data += TextUtils::format("%d",PurpleTeaminfo);

	//Use HTTP to report the match
	report_data += "&version=" + version;

	if(URL != ""){
		bz_addURLJob(URL.c_str(), NULL, report_data.c_str());
		bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, "Match Reported. All your scores will now be reset. No action is required on your part.");
	}else{
		bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, "Match Ended (but not reported). All your scores will now be reset.");
	}

	//Kill everyone, 'cause the match is over, and they're better off dead
	for (int i = 0; i < (int)playerList->size(); i++) {
		bz_sendTextMessage(BZ_SERVER, i, "Thank you for playing. Visit RPG's site at www.garrettsites.net for more plugins and BZ-related downloads.");
		bz_killPlayer(i, true, BZ_SERVER);
		//bz_resetPlayerScore(i);
	}

	bz_resetTeamScore(eRedTeam);
	bz_resetTeamScore(eGreenTeam);
	bz_resetTeamScore(eBlueTeam);
	bz_resetTeamScore(ePurpleTeam);

	match_in_progress = false;
}

void print_score(int blueScore, int redScore, int greenScore, int purpleScore, int player_id)
{
	bz_sendTextMessage(BZ_SERVER, player_id, "---CURRENT SCORE---");
	std::string score_text;

	if(bluePlay){
		score_text = "Blue Team: ";
		score_text += TextUtils::format("%d", blueScore);
		bz_sendTextMessage(BZ_SERVER, player_id, score_text.c_str());
	}

	if(redPlay){
		score_text = "Red Team: ";
		score_text += TextUtils::format("%d", redScore);
		bz_sendTextMessage(BZ_SERVER, player_id, score_text.c_str());
	}

	if(greenPlay){
		score_text = "Green Team: ";
		score_text += TextUtils::format("%d", greenScore);
		bz_sendTextMessage(BZ_SERVER, player_id, score_text.c_str());
	}

	if(purplePlay){
		score_text = "Purple Team: ";
		score_text += TextUtils::format("%d", purpleScore);
		bz_sendTextMessage(BZ_SERVER, player_id, score_text.c_str());
	}

	score_text = "Remember, the first team to ";
	score_text += TextUtils::format("%d", cap_num);
	score_text += " captures wins!";
	bz_sendTextMessage(BZ_SERVER, player_id, score_text.c_str());
}

//Below is everything related to the automatic functions

class RaceToSevenAutomatic : public bz_EventHandler
{
public:
        RaceToSevenAutomatic();
        virtual ~RaceToSevenAutomatic();
        virtual void process(bz_EventData *eventData);
};

RaceToSevenAutomatic::RaceToSevenAutomatic(){}

RaceToSevenAutomatic::~RaceToSevenAutomatic(){}

void RaceToSevenAutomatic::process (bz_EventData *eventData){
	if(eventData->eventType == bz_eCaptureEvent && match_in_progress){
		int blue_score = bz_getTeamWins(eBlueTeam);
		int red_score = bz_getTeamWins(eRedTeam);
		int green_score = bz_getTeamWins(eGreenTeam);
		int purple_score = bz_getTeamWins(ePurpleTeam);

		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == eBlueTeam) blue_score++;
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == eRedTeam) red_score++;
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == eGreenTeam) green_score++;
		if(((bz_CTFCaptureEventData*)eventData)->teamCapping == ePurpleTeam) purple_score++;
		print_score(blue_score, red_score, green_score, purple_score, BZ_ALLUSERS);

		//If the capper caped his own flag, punish the little boy
		if(((bz_CTFCaptureEventData*)eventData)->teamCapped == ((bz_CTFCaptureEventData*)eventData)->teamCapping) bz_kickUser(((bz_CTFCaptureEventData*)eventData)->playerCapping, "Wow, you really suck at this game, and at life, too. Here's a kick.", true);

		//Congratulate the capper
		bz_sendTextMessage(BZ_SERVER, ((bz_CTFCaptureEventData*)eventData)->playerCapping, "Congratulations, and on behalf of the server, we'd like to say thanks for using the Race to Seven plugin.");

		if(blue_score >= cap_num || red_score >= cap_num || green_score >= cap_num || purple_score >= cap_num) end_match(eventData);
	}

	//Kick anyone trying to join the server if there is a match in progress.
	if(eventData->eventType == bz_ePlayerJoinEvent && match_in_progress){
		//Make the player join observer
		int team_id = ((bz_PlayerJoinPartEventData*)eventData)->team;

		int playerID = ((bz_PlayerJoinPartEventData*)eventData)->playerID;
		bz_PlayerRecord *data = bz_getPlayerByIndex(playerID);
		if((team_id == eRogueTeam || team_id == eRedTeam || team_id == eGreenTeam || team_id == eBlueTeam || team_id == ePurpleTeam) && !data->admin && !allow_players){
			//Kick 'em if they're not an observer
			int joiners_id = ((bz_PlayerJoinPartEventData*)eventData)->playerID;
			bz_kickUser(joiners_id, "There a league match in progress. Please join observer.", true);
		}
	}

	//If there is nobody on the server, end the match, without reporting it.
	if(eventData->eventType == bz_ePlayerPartEvent && match_in_progress){
		bzAPIIntList	*playerList = bz_newIntList();
		bz_getPlayerIndexList(playerList);
		if(playerList->size() == 0) match_in_progress = false;
	}
}

RaceToSevenAutomatic	rtsa;

//Below is everything related to the manual commands
class RaceToSeven : public bz_CustomSlashCommandHandler{
public:
	virtual ~RaceToSeven(){};
	virtual bool handle(int playerID, bzApiString command, bzApiString message, bzAPIStringList *param);
};

RaceToSeven	raceToSeven;

BZF_PLUGIN_CALL int bz_Load(const char* commandLine){
	parseConfig(commandLine);

	bz_registerCustomSlashCommand("match",&raceToSeven);
	bz_registerEvent(bz_eCaptureEvent,&rtsa);
	bz_registerEvent(bz_ePlayerJoinEvent, &rtsa);
	bz_registerEvent(bz_ePlayerPartEvent, &rtsa);
	bz_debugMessage(1,"Race to 7 plugin loaded");
	return 0;
}

BZF_PLUGIN_CALL int bz_Unload(void){
	bz_removeCustomSlashCommand("match");
	bz_removeEvent(bz_eCaptureEvent,&rtsa);
	bz_removeEvent(bz_ePlayerJoinEvent,&rtsa);
	bz_removeEvent(bz_ePlayerPartEvent,&rtsa);
	bz_debugMessage(1,"Race to 7 plugin unloaded");
	return 0;
}

bool RaceToSeven::handle(int playerID, bzApiString _command, bzApiString _message, bzAPIStringList *_param)
{
	bz_PlayerRecord *fromPlayer = bz_getPlayerByIndex(playerID);
	bz_PlayerRecord *data = bz_getPlayerByIndex(playerID);

	std::vector<std::string> params = TextUtils::tokenize(_message.c_str(), std::string(" "));
	std::string myCommand = "";
	if(params.size() > 0) myCommand = params[0];

	if (myCommand == "start"){
		if(match_in_progress == true){
			bz_sendTextMessage(BZ_SERVER, playerID, "A match is already in progress!");
		}else{
			if(bz_hasPerm(playerID, "MATCHSTART") || data->admin){
				if(allow_matches){
					match_in_progress = true;
					bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, "A match has been started!");
					std::string start_message = "The first team to capture another's flag " + TextUtils::format("%d", cap_num) + " times wins!";
					bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, start_message.c_str());

					//Do a flagreset
					bz_resetFlags(false);

					//Reset the team scores
					bz_resetTeamScore(eRedTeam);
					bz_resetTeamScore(eGreenTeam);
					bz_resetTeamScore(eBlueTeam);
					bz_resetTeamScore(ePurpleTeam);

					//Find out which teams are playing in this match
					bluePlay = redPlay = greenPlay = purplePlay = false;
					bzAPIIntList	*playerList = bz_newIntList();
					bz_getPlayerIndexList(playerList);
					for(int i = 0; i < (int)playerList->size(); i++) {
						bz_PlayerRecord *data = bz_getPlayerByIndex(i);
						if(data->team == eRedTeam) redPlay = true;
						if(data->team == eGreenTeam) greenPlay = true;
						if(data->team == eBlueTeam) bluePlay = true;
						if(data->team == ePurpleTeam) purplePlay = true;
					}

					//Start logging
					report_data = "&starter=";
					report_data += TextUtils::format("%s", data->callsign.c_str());
					report_data += "&starterteam=";

					if(data->team == eRogueTeam) report_data += "Rogue";
					if(data->team == eRedTeam) report_data += "Red";
					if(data->team == eGreenTeam) report_data += "Green";
					if(data->team == eBlueTeam) report_data += "Blue";
					if(data->team == ePurpleTeam) report_data += "Purple";
					if(data->team == eObservers) report_data += "Observer";

					//Put all the current players in an std::map
					std::map<int, std::string> starting_players;
					for(int i = 0; i < (int)playerList->size(); i++){
						bz_PlayerRecord *data = bz_getPlayerByIndex(i);
						starting_players[i] = TextUtils::format("%s", data->callsign.c_str());
					}
				}else{
					bz_sendTextMessage(BZ_SERVER, playerID, "Currently, the administration is not allowing matches to take place.");
				}
			}else{
				bz_sendTextMessage(BZ_SERVER, playerID, "You do not have permission to run the match start command.");
			}
		}
		return true;
	}

	if(myCommand == "end"){
		if((data->admin == true || bz_hasPerm(playerID, "MATCHEND")) && match_in_progress){
			end_match(NULL);
		}else{
			bz_sendTextMessage(BZ_SERVER, playerID, "Obviously this isn't the time and you aren't the person to end a match.");
		}
		return true;
	}

	if(myCommand == "score"){
		if(match_in_progress){
			print_score(bz_getTeamWins(eBlueTeam), bz_getTeamWins(eRedTeam), bz_getTeamWins(eGreenTeam), bz_getTeamWins(ePurpleTeam), playerID);
		}else{
			bz_sendTextMessage(BZ_SERVER, playerID, "There is currently no match in progress.");
		}
		return true;
	}

	if(myCommand == "config"){
		if(params.size() == 1 || params[1] == "list"){
			//Print out the current configuration
			bz_sendTextMessage(BZ_SERVER, playerID, "-----Race to Seven Configuration List-----");
			std::string config_text = "Version: " + version;
			bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());

			config_text = "Captures to win: " + TextUtils::format("%d", cap_num);
			bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());

			config_text = "Allow players to join during a match: ";
			if(allow_players) config_text += "Yes";
			if(!allow_players) config_text += "No";
			bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());

			config_text = "URL to report matches to: " + URL;
			bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());

			if(allow_matches) config_text = "Matches are being allowed at this time.";
			if(!allow_matches) config_text = "Matches are not being allowed at this time.";
			bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());
		}else{
			if(params[1] == "set"){
				if(params.size() == 2){
					std::string config_text = "/match config set _allowMatches ";
					if(allow_matches) config_text += "true";
					if(!allow_matches) config_text += "false";
					bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());
					
					config_text = "/match config set _allowPlayersDuringMatch ";
					if(allow_players) config_text += "true";
					if(!allow_players) config_text += "false";
					bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());

					config_text = "/match config set _capNum " + TextUtils::format("%d", cap_num);
					bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());

					config_text = "/match config set _reportURL " + URL;
					bz_sendTextMessage(BZ_SERVER, playerID, config_text.c_str());
				}else{
					if(params.size() == 3) return false;
					if(params.size() == 4){
						if(bz_hasPerm(playerID, "MATCHCONFIG")){
							if(params[2] == "_allowPlayersDuringMatch"){
								if(params[3] == "true") allow_players = true;
								if(params[3] == "false") allow_players = false;
								if(params[3] != "true" && params[3] != "false"){
									bz_sendTextMessage(BZ_SERVER, playerID, "_allowPlayersDuringMatch must be set to either \"true\" or \"false\"");
									return true;
								}
								bz_sendTextMessage(BZ_SERVER, playerID, "_allowPlayersDuringMatch set");
								std::string mod_text = "Variable Modification Notice by " + TextUtils::format("%s", data->callsign.c_str()) + " of _allowPlayersDuringMatch " + params[3];
								bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, mod_text.c_str());
							}
							if(params[2] == "_capNum"){
								//Convert the string to an interger
								cap_num = strtol(params[3].c_str(), NULL, 10);
								if(cap_num == strtol(params[3].c_str(), NULL, 10)){
									bz_sendTextMessage(BZ_SERVER, playerID, "_capNum set");
									std::string mod_text = "Variable Modification Notice by " + TextUtils::format("%s", data->callsign.c_str()) + " of _capNum " + params[3];
									bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, mod_text.c_str());
								}
							}
							if(params[2] == "_reportURL"){
								URL = params[3];
								if(URL == params[3]){
									bz_sendTextMessage(BZ_SERVER, playerID, "_reportURL set");
									std::string mod_text = "Variable Modification Notice by " + TextUtils::format("%s", data->callsign.c_str()) + " of _reportURL " + params[3];
									bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, mod_text.c_str());
								}
							}
							if(params[2] == "_allowMatches"){
								if(params[3] == "true") allow_matches = true;
								if(params[3] == "false") allow_matches = false;
								if(params[3] != "true" && params[3] != "false"){
									bz_sendTextMessage(BZ_SERVER, playerID, "_allowMatches must be set to either \"true\" or \"false\"");
									return true;
								}
								bz_sendTextMessage(BZ_SERVER, playerID, "_allowMatches set");
								std::string mod_text = "Variable Modification Notice by " + TextUtils::format("%s", data->callsign.c_str()) + " of _allowMatches " + params[3];
								bz_sendTextMessage(BZ_SERVER, BZ_ALLUSERS, mod_text.c_str());
							}
						}else{
							bz_sendTextMessage(BZ_SERVER, playerID, "You do not have permission to run the match config set command.");
						}
					}
				}
			}else{
				if(params[1] == "reset"){
					if(params.size() == 3){
						if(bz_hasPerm(playerID, "MATCHCONFIG")){
							if(params[2] == "_allowPlayersDuringMatch"){
								allow_players = allow_players_orig;
								bz_sendTextMessage(BZ_SERVER, playerID, "_allowPlayersDuringMatch reset");
							}
							if(params[2] == "_capNum"){
								cap_num = cap_num_orig;
								bz_sendTextMessage(BZ_SERVER, playerID, "_capNum reset");
							}
							if(params[2] == "_reportURL"){
								URL = URL_orig;
								bz_sendTextMessage(BZ_SERVER, playerID, "_reportURL reset");
							}
							if(params[2] == "_allowMatches"){
								allow_matches = allow_matches_orig;
								bz_sendTextMessage(BZ_SERVER, playerID, "_allowMatches reset");
							}
						}else{
							bz_sendTextMessage(BZ_SERVER, playerID, "You do not have permission to run the match config reset command.");
						}
					}else{
						return false;
					}
				}else{
					bz_sendTextMessage(BZ_SERVER, playerID, "Use /match config set <name> <variable>, /match config reset <variable>, or /match config list.");
				}
			}
		}
		return true;
	}
	//If the command was not recognized, instead of telling them it doesn't exist, show the usage:
	bz_sendTextMessage(BZ_SERVER, playerID, "-*-------------------------------------------------*-");
	bz_sendTextMessage(BZ_SERVER, playerID, "Race to Seven BZFS plugin, (c) 2005 Garrett Padera (RPG) and A-Delusion");
	bz_sendTextMessage(BZ_SERVER, playerID, "-*-------------------------------------------------*-");
	bz_sendTextMessage(BZ_SERVER, playerID, "Usage for /match commands:");
	bz_sendTextMessage(BZ_SERVER, playerID, "-----COMMANDS YOU HAVE PERMISSION TO RUN-----");
	bz_sendTextMessage(BZ_SERVER, playerID, "/match score: Displays the match score");
	if(bz_hasPerm(playerID, "MATCHSTART") || data->admin) bz_sendTextMessage(BZ_SERVER, playerID, "/match start: Starts an official match");
	if(bz_hasPerm(playerID, "MATCHEND") || data->admin) bz_sendTextMessage(BZ_SERVER, playerID, "/match end: Forces the end of a match");
	if(bz_hasPerm(playerID, "MATCHCONFIG") || data->admin)bz_sendTextMessage(BZ_SERVER, playerID, "/match config <list|set> <name> <value>: Changes the configuration");
	bz_sendTextMessage(BZ_SERVER, playerID, "-----COMMANDS YOU DO NOT HAVE PERMISSION TO RUN-----");
	if(!bz_hasPerm(playerID, "MATCHSTART")) bz_sendTextMessage(BZ_SERVER, playerID, "/match start: Starts an official match");
	if(!bz_hasPerm(playerID, "MATCHEND")) bz_sendTextMessage(BZ_SERVER, playerID, "/match end: Forces the end of a match");
	if(!bz_hasPerm(playerID, "MATCHCONFIG")) bz_sendTextMessage(BZ_SERVER, playerID, "/match config <list|reset|set> <name> <value>: Changes the configuration");
	return true;
}

bool parseConfig(const char *filename){
	char buffer[1024];

	std::ifstream confStrm(filename);
	if(!confStrm.is_open()){
		bz_debugMessage(1, "RacetoSeven ERROR: Could not open config file. Using default values.");
		return false;
	}

	std::string stdbuffer;
	const char* option_name;
	while(confStrm.good()){
		confStrm.getline(buffer,1024);
		stdbuffer = buffer;

		std::vector<std::string> line = TextUtils::tokenize(stdbuffer, " ");

		if(line.size() >= 1){
			option_name = line[0].c_str();
			
			if(strcmp(option_name, "-capNum") == 0){
				cap_num = cap_num_orig = strtol(line[1].c_str(), NULL, 10);
				bz_debugMessage(1, "-capNum SET");
			}else if(strcmp(option_name, "-allowPlayersDuringMatch") == 0){
				if(line[1] == "true") allow_players = allow_players_orig = true;
				if(line[1] == "false") allow_players = allow_players_orig = false;
			}else if(strcmp(option_name, "-reportURL") == 0){
				URL = URL_orig = line[1];
			}else if(strcmp(option_name, "-allowMatches") == 0){
				if(line[1] == "true") allow_matches = allow_matches_orig = true;
				if(line[1] == "false") allow_matches = allow_matches_orig = false;
			}
		}
	}
	return true;
}
